# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from edge_impulse_sdk.configuration import Configuration


class AddApiKeyRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'api_key': 'str',
        'is_development_key': 'bool',
        'role': 'str'
    }

    attribute_map = {
        'name': 'name',
        'api_key': 'apiKey',
        'is_development_key': 'isDevelopmentKey',
        'role': 'role'
    }

    def __init__(self, name=None, api_key=None, is_development_key=None, role=None, local_vars_configuration=None):  # noqa: E501
        """AddApiKeyRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._api_key = None
        self._is_development_key = None
        self._role = None
        self.discriminator = None

        self.name = name
        self.api_key = api_key
        self.is_development_key = is_development_key
        self.role = role

    @property
    def name(self):
        """Gets the name of this AddApiKeyRequest.  # noqa: E501

        Description of the key  # noqa: E501

        :return: The name of this AddApiKeyRequest.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AddApiKeyRequest.

        Description of the key  # noqa: E501

        :param name: The name of this AddApiKeyRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def api_key(self):
        """Gets the api_key of this AddApiKeyRequest.  # noqa: E501

        API key. This needs to start with `ei_` and will need to be at least 32 characters long.  # noqa: E501

        :return: The api_key of this AddApiKeyRequest.  # noqa: E501
        :rtype: str
        """
        return self._api_key

    @api_key.setter
    def api_key(self, api_key):
        """Sets the api_key of this AddApiKeyRequest.

        API key. This needs to start with `ei_` and will need to be at least 32 characters long.  # noqa: E501

        :param api_key: The api_key of this AddApiKeyRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and api_key is None:  # noqa: E501
            raise ValueError("Invalid value for `api_key`, must not be `None`")  # noqa: E501

        self._api_key = api_key

    @property
    def is_development_key(self):
        """Gets the is_development_key of this AddApiKeyRequest.  # noqa: E501

        Whether this key should be used as a development key.  # noqa: E501

        :return: The is_development_key of this AddApiKeyRequest.  # noqa: E501
        :rtype: bool
        """
        return self._is_development_key

    @is_development_key.setter
    def is_development_key(self, is_development_key):
        """Sets the is_development_key of this AddApiKeyRequest.

        Whether this key should be used as a development key.  # noqa: E501

        :param is_development_key: The is_development_key of this AddApiKeyRequest.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and is_development_key is None:  # noqa: E501
            raise ValueError("Invalid value for `is_development_key`, must not be `None`")  # noqa: E501

        self._is_development_key = is_development_key

    @property
    def role(self):
        """Gets the role of this AddApiKeyRequest.  # noqa: E501


        :return: The role of this AddApiKeyRequest.  # noqa: E501
        :rtype: str
        """
        return self._role

    @role.setter
    def role(self, role):
        """Sets the role of this AddApiKeyRequest.


        :param role: The role of this AddApiKeyRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and role is None:  # noqa: E501
            raise ValueError("Invalid value for `role`, must not be `None`")  # noqa: E501
        allowed_values = ["admin", "readonly", "ingestiononly"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and role not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `role` ({0}), must be one of {1}"  # noqa: E501
                .format(role, allowed_values)
            )

        self._role = role

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddApiKeyRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AddApiKeyRequest):
            return True

        return self.to_dict() != other.to_dict()
