# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from edge_impulse_sdk.configuration import Configuration


class GetSampleResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'success': 'bool',
        'error': 'str',
        'sample': 'Sample',
        'payload': 'RawSamplePayload',
        'total_payload_length': 'int'
    }

    attribute_map = {
        'success': 'success',
        'error': 'error',
        'sample': 'sample',
        'payload': 'payload',
        'total_payload_length': 'totalPayloadLength'
    }

    def __init__(self, success=None, error=None, sample=None, payload=None, total_payload_length=None, local_vars_configuration=None):  # noqa: E501
        """GetSampleResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._success = None
        self._error = None
        self._sample = None
        self._payload = None
        self._total_payload_length = None
        self.discriminator = None

        self.success = success
        if error is not None:
            self.error = error
        self.sample = sample
        self.payload = payload
        self.total_payload_length = total_payload_length

    @property
    def success(self):
        """Gets the success of this GetSampleResponse.  # noqa: E501

        Whether the operation succeeded  # noqa: E501

        :return: The success of this GetSampleResponse.  # noqa: E501
        :rtype: bool
        """
        return self._success

    @success.setter
    def success(self, success):
        """Sets the success of this GetSampleResponse.

        Whether the operation succeeded  # noqa: E501

        :param success: The success of this GetSampleResponse.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and success is None:  # noqa: E501
            raise ValueError("Invalid value for `success`, must not be `None`")  # noqa: E501

        self._success = success

    @property
    def error(self):
        """Gets the error of this GetSampleResponse.  # noqa: E501

        Optional error description (set if 'success' was false)  # noqa: E501

        :return: The error of this GetSampleResponse.  # noqa: E501
        :rtype: str
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this GetSampleResponse.

        Optional error description (set if 'success' was false)  # noqa: E501

        :param error: The error of this GetSampleResponse.  # noqa: E501
        :type: str
        """

        self._error = error

    @property
    def sample(self):
        """Gets the sample of this GetSampleResponse.  # noqa: E501


        :return: The sample of this GetSampleResponse.  # noqa: E501
        :rtype: Sample
        """
        return self._sample

    @sample.setter
    def sample(self, sample):
        """Sets the sample of this GetSampleResponse.


        :param sample: The sample of this GetSampleResponse.  # noqa: E501
        :type: Sample
        """
        if self.local_vars_configuration.client_side_validation and sample is None:  # noqa: E501
            raise ValueError("Invalid value for `sample`, must not be `None`")  # noqa: E501

        self._sample = sample

    @property
    def payload(self):
        """Gets the payload of this GetSampleResponse.  # noqa: E501


        :return: The payload of this GetSampleResponse.  # noqa: E501
        :rtype: RawSamplePayload
        """
        return self._payload

    @payload.setter
    def payload(self, payload):
        """Sets the payload of this GetSampleResponse.


        :param payload: The payload of this GetSampleResponse.  # noqa: E501
        :type: RawSamplePayload
        """
        if self.local_vars_configuration.client_side_validation and payload is None:  # noqa: E501
            raise ValueError("Invalid value for `payload`, must not be `None`")  # noqa: E501

        self._payload = payload

    @property
    def total_payload_length(self):
        """Gets the total_payload_length of this GetSampleResponse.  # noqa: E501

        Total number of payload values  # noqa: E501

        :return: The total_payload_length of this GetSampleResponse.  # noqa: E501
        :rtype: int
        """
        return self._total_payload_length

    @total_payload_length.setter
    def total_payload_length(self, total_payload_length):
        """Sets the total_payload_length of this GetSampleResponse.

        Total number of payload values  # noqa: E501

        :param total_payload_length: The total_payload_length of this GetSampleResponse.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and total_payload_length is None:  # noqa: E501
            raise ValueError("Invalid value for `total_payload_length`, must not be `None`")  # noqa: E501

        self._total_payload_length = total_payload_length

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetSampleResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GetSampleResponse):
            return True

        return self.to_dict() != other.to_dict()
