# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from edge_impulse_sdk.configuration import Configuration


class ImpulseBlockVersion(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'primary_version': 'bool',
        'name': 'str',
        'description': 'str',
        'dsp': 'list[int]',
        'axes': 'list[str]',
        'input': 'float',
        'window_size_ms': 'int',
        'window_increase_ms': 'int',
        'pad_zeros': 'bool',
        'image_width': 'int',
        'image_height': 'int',
        'resize_mode': 'str',
        'resize_method': 'str',
        'crop_anchor': 'str'
    }

    attribute_map = {
        'id': 'id',
        'primary_version': 'primaryVersion',
        'name': 'name',
        'description': 'description',
        'dsp': 'dsp',
        'axes': 'axes',
        'input': 'input',
        'window_size_ms': 'windowSizeMs',
        'window_increase_ms': 'windowIncreaseMs',
        'pad_zeros': 'padZeros',
        'image_width': 'imageWidth',
        'image_height': 'imageHeight',
        'resize_mode': 'resizeMode',
        'resize_method': 'resizeMethod',
        'crop_anchor': 'cropAnchor'
    }

    def __init__(self, id=None, primary_version=None, name=None, description=None, dsp=None, axes=None, input=None, window_size_ms=None, window_increase_ms=None, pad_zeros=None, image_width=None, image_height=None, resize_mode=None, resize_method=None, crop_anchor=None, local_vars_configuration=None):  # noqa: E501
        """ImpulseBlockVersion - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._primary_version = None
        self._name = None
        self._description = None
        self._dsp = None
        self._axes = None
        self._input = None
        self._window_size_ms = None
        self._window_increase_ms = None
        self._pad_zeros = None
        self._image_width = None
        self._image_height = None
        self._resize_mode = None
        self._resize_method = None
        self._crop_anchor = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if primary_version is not None:
            self.primary_version = primary_version
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if dsp is not None:
            self.dsp = dsp
        if axes is not None:
            self.axes = axes
        if input is not None:
            self.input = input
        if window_size_ms is not None:
            self.window_size_ms = window_size_ms
        if window_increase_ms is not None:
            self.window_increase_ms = window_increase_ms
        if pad_zeros is not None:
            self.pad_zeros = pad_zeros
        if image_width is not None:
            self.image_width = image_width
        if image_height is not None:
            self.image_height = image_height
        if resize_mode is not None:
            self.resize_mode = resize_mode
        if resize_method is not None:
            self.resize_method = resize_method
        if crop_anchor is not None:
            self.crop_anchor = crop_anchor

    @property
    def id(self):
        """Gets the id of this ImpulseBlockVersion.  # noqa: E501

        Identifier for the new block version. Make sure to up this number when creating a new block, and don't re-use identifiers.  # noqa: E501

        :return: The id of this ImpulseBlockVersion.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ImpulseBlockVersion.

        Identifier for the new block version. Make sure to up this number when creating a new block, and don't re-use identifiers.  # noqa: E501

        :param id: The id of this ImpulseBlockVersion.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def primary_version(self):
        """Gets the primary_version of this ImpulseBlockVersion.  # noqa: E501

        Whether this block is the primary version of its base block.  # noqa: E501

        :return: The primary_version of this ImpulseBlockVersion.  # noqa: E501
        :rtype: bool
        """
        return self._primary_version

    @primary_version.setter
    def primary_version(self, primary_version):
        """Sets the primary_version of this ImpulseBlockVersion.

        Whether this block is the primary version of its base block.  # noqa: E501

        :param primary_version: The primary_version of this ImpulseBlockVersion.  # noqa: E501
        :type: bool
        """

        self._primary_version = primary_version

    @property
    def name(self):
        """Gets the name of this ImpulseBlockVersion.  # noqa: E501

        Block name, will be used in menus. If a block has a baseBlockId, this field is ignored and the base block's name is used instead.  # noqa: E501

        :return: The name of this ImpulseBlockVersion.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ImpulseBlockVersion.

        Block name, will be used in menus. If a block has a baseBlockId, this field is ignored and the base block's name is used instead.  # noqa: E501

        :param name: The name of this ImpulseBlockVersion.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this ImpulseBlockVersion.  # noqa: E501

        A short description of the block version, displayed in the block versioning UI  # noqa: E501

        :return: The description of this ImpulseBlockVersion.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ImpulseBlockVersion.

        A short description of the block version, displayed in the block versioning UI  # noqa: E501

        :param description: The description of this ImpulseBlockVersion.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def dsp(self):
        """Gets the dsp of this ImpulseBlockVersion.  # noqa: E501

        (Learn only) DSP dependencies, identified by DSP block ID  # noqa: E501

        :return: The dsp of this ImpulseBlockVersion.  # noqa: E501
        :rtype: list[int]
        """
        return self._dsp

    @dsp.setter
    def dsp(self, dsp):
        """Sets the dsp of this ImpulseBlockVersion.

        (Learn only) DSP dependencies, identified by DSP block ID  # noqa: E501

        :param dsp: The dsp of this ImpulseBlockVersion.  # noqa: E501
        :type: list[int]
        """

        self._dsp = dsp

    @property
    def axes(self):
        """Gets the axes of this ImpulseBlockVersion.  # noqa: E501

        (DSP only) Input axes, identified by the name in the name of the axis  # noqa: E501

        :return: The axes of this ImpulseBlockVersion.  # noqa: E501
        :rtype: list[str]
        """
        return self._axes

    @axes.setter
    def axes(self, axes):
        """Sets the axes of this ImpulseBlockVersion.

        (DSP only) Input axes, identified by the name in the name of the axis  # noqa: E501

        :param axes: The axes of this ImpulseBlockVersion.  # noqa: E501
        :type: list[str]
        """

        self._axes = axes

    @property
    def input(self):
        """Gets the input of this ImpulseBlockVersion.  # noqa: E501

        (DSP only) The ID of the Input block a DSP block is connected to  # noqa: E501

        :return: The input of this ImpulseBlockVersion.  # noqa: E501
        :rtype: float
        """
        return self._input

    @input.setter
    def input(self, input):
        """Sets the input of this ImpulseBlockVersion.

        (DSP only) The ID of the Input block a DSP block is connected to  # noqa: E501

        :param input: The input of this ImpulseBlockVersion.  # noqa: E501
        :type: float
        """

        self._input = input

    @property
    def window_size_ms(self):
        """Gets the window_size_ms of this ImpulseBlockVersion.  # noqa: E501

        (Input only) Size of the sliding window in milliseconds  # noqa: E501

        :return: The window_size_ms of this ImpulseBlockVersion.  # noqa: E501
        :rtype: int
        """
        return self._window_size_ms

    @window_size_ms.setter
    def window_size_ms(self, window_size_ms):
        """Sets the window_size_ms of this ImpulseBlockVersion.

        (Input only) Size of the sliding window in milliseconds  # noqa: E501

        :param window_size_ms: The window_size_ms of this ImpulseBlockVersion.  # noqa: E501
        :type: int
        """

        self._window_size_ms = window_size_ms

    @property
    def window_increase_ms(self):
        """Gets the window_increase_ms of this ImpulseBlockVersion.  # noqa: E501

        (Input only) We use a sliding window to go over the raw data. How many milliseconds to increase the sliding window with for each step.  # noqa: E501

        :return: The window_increase_ms of this ImpulseBlockVersion.  # noqa: E501
        :rtype: int
        """
        return self._window_increase_ms

    @window_increase_ms.setter
    def window_increase_ms(self, window_increase_ms):
        """Sets the window_increase_ms of this ImpulseBlockVersion.

        (Input only) We use a sliding window to go over the raw data. How many milliseconds to increase the sliding window with for each step.  # noqa: E501

        :param window_increase_ms: The window_increase_ms of this ImpulseBlockVersion.  # noqa: E501
        :type: int
        """

        self._window_increase_ms = window_increase_ms

    @property
    def pad_zeros(self):
        """Gets the pad_zeros of this ImpulseBlockVersion.  # noqa: E501

        (Input only) Whether to zero pad data when there is not enough data.  # noqa: E501

        :return: The pad_zeros of this ImpulseBlockVersion.  # noqa: E501
        :rtype: bool
        """
        return self._pad_zeros

    @pad_zeros.setter
    def pad_zeros(self, pad_zeros):
        """Sets the pad_zeros of this ImpulseBlockVersion.

        (Input only) Whether to zero pad data when there is not enough data.  # noqa: E501

        :param pad_zeros: The pad_zeros of this ImpulseBlockVersion.  # noqa: E501
        :type: bool
        """

        self._pad_zeros = pad_zeros

    @property
    def image_width(self):
        """Gets the image_width of this ImpulseBlockVersion.  # noqa: E501

        (Input only) Width all images are resized to before training  # noqa: E501

        :return: The image_width of this ImpulseBlockVersion.  # noqa: E501
        :rtype: int
        """
        return self._image_width

    @image_width.setter
    def image_width(self, image_width):
        """Sets the image_width of this ImpulseBlockVersion.

        (Input only) Width all images are resized to before training  # noqa: E501

        :param image_width: The image_width of this ImpulseBlockVersion.  # noqa: E501
        :type: int
        """

        self._image_width = image_width

    @property
    def image_height(self):
        """Gets the image_height of this ImpulseBlockVersion.  # noqa: E501

        (Input only) Width all images are resized to before training  # noqa: E501

        :return: The image_height of this ImpulseBlockVersion.  # noqa: E501
        :rtype: int
        """
        return self._image_height

    @image_height.setter
    def image_height(self, image_height):
        """Sets the image_height of this ImpulseBlockVersion.

        (Input only) Width all images are resized to before training  # noqa: E501

        :param image_height: The image_height of this ImpulseBlockVersion.  # noqa: E501
        :type: int
        """

        self._image_height = image_height

    @property
    def resize_mode(self):
        """Gets the resize_mode of this ImpulseBlockVersion.  # noqa: E501

        (Input only) How to resize images before training  # noqa: E501

        :return: The resize_mode of this ImpulseBlockVersion.  # noqa: E501
        :rtype: str
        """
        return self._resize_mode

    @resize_mode.setter
    def resize_mode(self, resize_mode):
        """Sets the resize_mode of this ImpulseBlockVersion.

        (Input only) How to resize images before training  # noqa: E501

        :param resize_mode: The resize_mode of this ImpulseBlockVersion.  # noqa: E501
        :type: str
        """
        allowed_values = ["squash", "fit-short", "fit-long", "crop"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and resize_mode not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `resize_mode` ({0}), must be one of {1}"  # noqa: E501
                .format(resize_mode, allowed_values)
            )

        self._resize_mode = resize_mode

    @property
    def resize_method(self):
        """Gets the resize_method of this ImpulseBlockVersion.  # noqa: E501

        (Input only) Resize method to use when resizing images  # noqa: E501

        :return: The resize_method of this ImpulseBlockVersion.  # noqa: E501
        :rtype: str
        """
        return self._resize_method

    @resize_method.setter
    def resize_method(self, resize_method):
        """Sets the resize_method of this ImpulseBlockVersion.

        (Input only) Resize method to use when resizing images  # noqa: E501

        :param resize_method: The resize_method of this ImpulseBlockVersion.  # noqa: E501
        :type: str
        """
        allowed_values = ["lanczos3", "nearest"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and resize_method not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `resize_method` ({0}), must be one of {1}"  # noqa: E501
                .format(resize_method, allowed_values)
            )

        self._resize_method = resize_method

    @property
    def crop_anchor(self):
        """Gets the crop_anchor of this ImpulseBlockVersion.  # noqa: E501

        (Input only) If images are resized using a crop, choose where to anchor the crop  # noqa: E501

        :return: The crop_anchor of this ImpulseBlockVersion.  # noqa: E501
        :rtype: str
        """
        return self._crop_anchor

    @crop_anchor.setter
    def crop_anchor(self, crop_anchor):
        """Sets the crop_anchor of this ImpulseBlockVersion.

        (Input only) If images are resized using a crop, choose where to anchor the crop  # noqa: E501

        :param crop_anchor: The crop_anchor of this ImpulseBlockVersion.  # noqa: E501
        :type: str
        """
        allowed_values = ["top-left", "top-center", "top-right", "middle-left", "middle-center", "middle-right", "bottom-left", "bottom-center", "bottom-right"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and crop_anchor not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `crop_anchor` ({0}), must be one of {1}"  # noqa: E501
                .format(crop_anchor, allowed_values)
            )

        self._crop_anchor = crop_anchor

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ImpulseBlockVersion):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ImpulseBlockVersion):
            return True

        return self.to_dict() != other.to_dict()
