# coding: utf-8

"""
    Edge Impulse API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from edge_impulse_sdk.configuration import Configuration


class ImpulseLearnBlock(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'type': 'str',
        'name': 'str',
        'dsp': 'list[int]',
        'title': 'str',
        'primary_version': 'bool',
        'base_block_id': 'float',
        'description': 'str',
        'created_by': 'str',
        'created_at': 'datetime'
    }

    attribute_map = {
        'id': 'id',
        'type': 'type',
        'name': 'name',
        'dsp': 'dsp',
        'title': 'title',
        'primary_version': 'primaryVersion',
        'base_block_id': 'baseBlockId',
        'description': 'description',
        'created_by': 'createdBy',
        'created_at': 'createdAt'
    }

    def __init__(self, id=None, type=None, name=None, dsp=None, title=None, primary_version=None, base_block_id=None, description=None, created_by=None, created_at=None, local_vars_configuration=None):  # noqa: E501
        """ImpulseLearnBlock - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._type = None
        self._name = None
        self._dsp = None
        self._title = None
        self._primary_version = None
        self._base_block_id = None
        self._description = None
        self._created_by = None
        self._created_at = None
        self.discriminator = None

        self.id = id
        self.type = type
        self.name = name
        self.dsp = dsp
        self.title = title
        self.primary_version = primary_version
        if base_block_id is not None:
            self.base_block_id = base_block_id
        if description is not None:
            self.description = description
        if created_by is not None:
            self.created_by = created_by
        if created_at is not None:
            self.created_at = created_at

    @property
    def id(self):
        """Gets the id of this ImpulseLearnBlock.  # noqa: E501

        Identifier for this block. Make sure to up this number when creating a new block, and don't re-use identifiers. If the block hasn't changed, keep the ID as-is.  # noqa: E501

        :return: The id of this ImpulseLearnBlock.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ImpulseLearnBlock.

        Identifier for this block. Make sure to up this number when creating a new block, and don't re-use identifiers. If the block hasn't changed, keep the ID as-is.  # noqa: E501

        :param id: The id of this ImpulseLearnBlock.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def type(self):
        """Gets the type of this ImpulseLearnBlock.  # noqa: E501

        Block type (either keras, keras-transfer-image, keras-object-detection, keras-regression, or anomaly)  # noqa: E501

        :return: The type of this ImpulseLearnBlock.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ImpulseLearnBlock.

        Block type (either keras, keras-transfer-image, keras-object-detection, keras-regression, or anomaly)  # noqa: E501

        :param type: The type of this ImpulseLearnBlock.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and type is None:  # noqa: E501
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def name(self):
        """Gets the name of this ImpulseLearnBlock.  # noqa: E501

        Block name, will be used in menus. If a block has a baseBlockId, this field is ignored and the base block's name is used instead.  # noqa: E501

        :return: The name of this ImpulseLearnBlock.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ImpulseLearnBlock.

        Block name, will be used in menus. If a block has a baseBlockId, this field is ignored and the base block's name is used instead.  # noqa: E501

        :param name: The name of this ImpulseLearnBlock.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def dsp(self):
        """Gets the dsp of this ImpulseLearnBlock.  # noqa: E501

        DSP dependencies, identified by DSP block ID  # noqa: E501

        :return: The dsp of this ImpulseLearnBlock.  # noqa: E501
        :rtype: list[int]
        """
        return self._dsp

    @dsp.setter
    def dsp(self, dsp):
        """Sets the dsp of this ImpulseLearnBlock.

        DSP dependencies, identified by DSP block ID  # noqa: E501

        :param dsp: The dsp of this ImpulseLearnBlock.  # noqa: E501
        :type: list[int]
        """
        if self.local_vars_configuration.client_side_validation and dsp is None:  # noqa: E501
            raise ValueError("Invalid value for `dsp`, must not be `None`")  # noqa: E501

        self._dsp = dsp

    @property
    def title(self):
        """Gets the title of this ImpulseLearnBlock.  # noqa: E501

        Block title, used in the impulse UI  # noqa: E501

        :return: The title of this ImpulseLearnBlock.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this ImpulseLearnBlock.

        Block title, used in the impulse UI  # noqa: E501

        :param title: The title of this ImpulseLearnBlock.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and title is None:  # noqa: E501
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def primary_version(self):
        """Gets the primary_version of this ImpulseLearnBlock.  # noqa: E501

        Whether this block is the primary version of its base block.  # noqa: E501

        :return: The primary_version of this ImpulseLearnBlock.  # noqa: E501
        :rtype: bool
        """
        return self._primary_version

    @primary_version.setter
    def primary_version(self, primary_version):
        """Sets the primary_version of this ImpulseLearnBlock.

        Whether this block is the primary version of its base block.  # noqa: E501

        :param primary_version: The primary_version of this ImpulseLearnBlock.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and primary_version is None:  # noqa: E501
            raise ValueError("Invalid value for `primary_version`, must not be `None`")  # noqa: E501

        self._primary_version = primary_version

    @property
    def base_block_id(self):
        """Gets the base_block_id of this ImpulseLearnBlock.  # noqa: E501

        The version number of the original block this version was based on. If this is an original block, will be undefined.  # noqa: E501

        :return: The base_block_id of this ImpulseLearnBlock.  # noqa: E501
        :rtype: float
        """
        return self._base_block_id

    @base_block_id.setter
    def base_block_id(self, base_block_id):
        """Sets the base_block_id of this ImpulseLearnBlock.

        The version number of the original block this version was based on. If this is an original block, will be undefined.  # noqa: E501

        :param base_block_id: The base_block_id of this ImpulseLearnBlock.  # noqa: E501
        :type: float
        """

        self._base_block_id = base_block_id

    @property
    def description(self):
        """Gets the description of this ImpulseLearnBlock.  # noqa: E501

        A short description of the block version, displayed in the block versioning UI  # noqa: E501

        :return: The description of this ImpulseLearnBlock.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ImpulseLearnBlock.

        A short description of the block version, displayed in the block versioning UI  # noqa: E501

        :param description: The description of this ImpulseLearnBlock.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def created_by(self):
        """Gets the created_by of this ImpulseLearnBlock.  # noqa: E501

        The system component that created the block version (createImpulse | clone | tuner). Cannot be set via API.  # noqa: E501

        :return: The created_by of this ImpulseLearnBlock.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this ImpulseLearnBlock.

        The system component that created the block version (createImpulse | clone | tuner). Cannot be set via API.  # noqa: E501

        :param created_by: The created_by of this ImpulseLearnBlock.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def created_at(self):
        """Gets the created_at of this ImpulseLearnBlock.  # noqa: E501

        The datetime that the block version was created. Cannot be set via API.  # noqa: E501

        :return: The created_at of this ImpulseLearnBlock.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this ImpulseLearnBlock.

        The datetime that the block version was created. Cannot be set via API.  # noqa: E501

        :param created_at: The created_at of this ImpulseLearnBlock.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ImpulseLearnBlock):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ImpulseLearnBlock):
            return True

        return self.to_dict() != other.to_dict()
